/*
*********************************************
*											*
*		Astro TIME functions				*
*											*
*********************************************
*/
#ifndef		_ATIME_H
#define		_ATIME_H
#include "astro.h"

/* const TT to TCG */
#define		CONST_LGG	(CONST_LG / (1.0 - CONST_LG))


/*
-----------------------------------------
		Reap second
-----------------------------------------
*/
typedef struct tag_leap{
	double dJD;
	double dTime;
} LEAPSEC;


/*
=========================================
			prototype
=========================================
*/
/*
-----------------------------------------
		date to julian
-----------------------------------------
*/
void date_julian_ljd(ADATE *pAdate, LONGJD *pLjd);
void dtime_julian_ljd(DATETIME *pADT, LONGJD *pLjd);
double date_julian(ADATE *pAdate);
double dtime_julian(DATETIME *pADT);

/*
-----------------------------------------
		julian to date
-----------------------------------------
*/
void juian_date_ljd(LONGJD *pLjd, ADATE *pAdate);
void juian_dtime_ljd(LONGJD *pLjd, DATETIME *pADT);
void juian_date(double dJD, ADATE *pAdate);
void juian_dtime(double dJD, DATETIME *pADT);

int jd_period(double dJD, int nPerioDay);
void dayfrac_time(double dDayFrac, ATIME *pAtime);

/* UTC <-> TT function */
void set_dtt_table(LEAPSEC *pdTbl);
double utc_tt(DATETIME *pUTC, LONGJD *pdJDtt);
double utc_tt_jd(LONGJD *pdJDutc, LONGJD *pdJDtt);
double tt_utc(LONGJD *pdJD_tt, DATETIME *pUTC);
double tt_utc_jd(LONGJD *pdJDtt, LONGJD *pdJDutc);

/* TCG - TT */
double tt_tcg(LONGJD *pdJDtt, LONGJD *pdJDtcg);
double tcg_tt(LONGJD *pdJDtcg, LONGJD *pdJDtt);

/* longJD functions */
void ljd_normalize(LONGJD *pjd);
void jdtoljd(double dJD, LONGJD *plJD);
double ljdtojd(LONGJD *plJD);

#endif
